<template>
  <div class="guest_page">
    <div class="bg-wrapper">
      <Background></Background>
    </div>
    <div class="guest_page_container">
      <a href="https://www.heta.org" class="logo_link">
        <div class="logo_container">
          <img :src="`${$baseUrl}/images/logo-HETA2.png`" alt="HETACHAIN" class="img">
        </div>
      </a>
      <div class="guest_page_form">
        <div class="form-container">
          <div class="guest_page_form_header">
            <div class="title">{{ $t('auth.login.title') }}</div>
            <div class="sub_title">{{ $t('auth.login.note') }}</div>
          </div>

          <div class="guest_page_form_body">
            <div class="safe_link_container">
              <a href="https://dashboard.heta.org"
                 class="iconmo-lock iconmo-icon"></a>
              <a href="https://dashboard.heta.org" class="link">https://dashboard.heta.org</a>
            </div>
            <div class="input_group">
              <div class="input_group_prepend"><i class="iconmo-email"></i></div>
              <input class="form_input"
                     data-vv-validate-on="none"
                     @keyup.enter="login"
                     v-validate="'required|email'"
                     @focus="resetError"
                     v-model="email"
                     type="email"
                     :placeholder="$t('auth.placeholder.email')"
                     name="email">
              <span class="invalid-feedback" v-if="errors.has('email')">
                {{ errors.first('email') }}
                <a href="javascript:void(0)" style="text-decoration: underline" v-if="errors.count() === 1 && errors.first('email') === $t('validation.email_verify', {attribute: 'email'})"
                   @click="sendVerifyUser"> {{$t('sign.resend')}} </a>
              </span>
            </div>

            <div class="input_group">
              <div class="input_group_prepend">
                <i class="iconmo-password"></i>
              </div>
              <input data-vv-validate-on="none"
                     @keyup.enter="login"
                     v-validate="'required'"
                     @focus="resetError"
                     v-model="password"
                     :placeholder="$t('auth.placeholder.password')"
                     name="password"
                     type="password"
                     class="form_input">
              <span class="invalid-feedback" v-if="errors.has('password')">{{ errors.first('password') }}</span>
            </div>

            <div class="form_actions">
              <button type="button" class="button-primary" @click="login">{{ $t('auth.btn.upper_login') }}</button>
            </div>
            <div class="form_footer">
              <p class="text-normal text-forgot text-link" @click="$router.push('/reset-password')">{{ $t('auth.login.forgot_password') }}</p>

              <div class="register-box">
                <p class="text-normal">
                  {{ $t('auth.login.not_have_account') }}
                  <span class="text-normal text-register" @click="gotoRegisterPage()">{{ $t('auth.btn.register')}}</span>
                </p>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <guest-page-footer></guest-page-footer>
    <modal v-if="displayModal" @close="modalOff">
      <component v-bind:is="currentModal" :modal-data="modalData"></component>
    </modal>
  </div>
</template>

<script>
  import { mapState } from 'vuex';
  import rf from '../../../common/requests/RequestFactory';
  import CheckAuthMixin from './CheckAuthMixin';
  import ModalMixin from '../../../common/components/ModalMixin';
  import OtpConfirmModal from '../../../common/components/Otp/OtpConfirmModal.vue';
  import GuestPageFooter from '../../components/GuestPageFooter.vue';
  import Background from '../../components/Dashboard/Background';

  export default {
    components: {
      GuestPageFooter,
      Background
    },
    data () {
      return {
        email: '',
        password: '',
      };
    },
    mixins: [CheckAuthMixin, ModalMixin],
    computed: {
      ...mapState([
        'supportedLocales',
      ]),
    },
    methods: {
      sendVerifyUser() {
        if (this.email) {
          rf.getRequest('UserRequest').sendVerifyUser({email: this.email}).then(() => {
            this.$toasted.show(this.$t('sign.resend_successful'), {
              theme: 'bubble',
              position: 'top-right',
              duration: 2000
            });
          });
        }
      },
      resetError () {
        if (this.errors.any()) {
          this.errors.clear();
        }
      },
      gotoRegisterPage () {
        this.$router.push('/register');
      },
      login () {
        this.$validator.validateAll()
          .then(() => {
            if (this.errors.any()) {
              return;
            }
            const params = Object.assign({}, {
              email: this.email,
              password: this.password,
            });
            rf.getRequest('UserRequest').login(params)
              .then((res) => {
                window.location.href = '/';
              })
              .catch((error) => {
                const errors = error.errors;
                this.initErrors(errors);
                if (this.errors.has('code')) {
                  this.errors.clear();
                  this.$broadcast('open-modal', OtpConfirmModal, {
                    callback: this.requestLogin,
                    key: `${this._uid}-login`,
                    params: params,
                  });
                }
              });
          });
      },
      initErrors (errors) {
        this.errors.clear();
        Object.keys(errors).forEach((key) => {
          this.errors.add({
            field: key,
            msg: errors[key][0]
          });
        });
      },
      requestLogin (params) {
        return rf.getRequest('UserRequest').login(params);
      },
    },
    created () {
      this.$on(`${this._uid}-login-callback-has-errors`, (errors) => {
        this.initErrors(errors);
      });
      this.$on(`${this._uid}-login-confirm-otp-successful`, () => {
        window.location.href = '/';
      });
    },
  }
</script>

<style lang="scss" scoped>
  .guest_page {
    overflow: hidden;
  }

  .form_footer {
    margin-top: 27px;
    text-align: center;
    .text-forgot {
      margin-bottom: 2px;
      cursor: pointer;
    }
    .register-box {
      .text-register {
        font-family: Roboto;
        font-size: 12px;
        font-weight: bold;
        font-style: normal;
        font-stretch: normal;
        line-height: 2.5;
        letter-spacing: 0.5px;
        text-align: center;
        color: #fa7300;
        cursor: pointer;
        &:hover {
          text-decoration: underline;
        }
      }
    }
  }

  .logo_link {
    display: inline-block;
  }

  @media screen and (max-width: 1023px) {
    .logo_link {
      margin-bottom: 40px;
    }
    .guest_page_container {
      text-align: center;
    }
    .guest_page {
      .guest_page_form {
        display: block;
        position: static;
        transform: translateY(0);
        padding-left: 0 !important;

        .form-container {
          margin: 0 auto;
          text-align: left;
        }
      }
    }
  }
</style>
